﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Steema.TeeChart;
using Steema.TeeChart.Styles;

namespace TeeChartExample
{
    public partial class Form1 : Form
    {
        private TChart tChart;
        private Line[] lines = new Line[10];
        private System.Timers.Timer timer = new System.Timers.Timer(1000);
        private Random random = new Random();
        private readonly object chartLock = new object();

        public Form1()
        {
            InitializeComponent();

            this.tChart = new TChart();

            for(int i = 0; i < this.lines.Length; i++)
            {
                this.lines[i] = new Line() { Title = "line" + i };
                this.tChart.Series.Add(this.lines[i]);
                this.lines[i].Add(DateTime.Now, this.random.NextDouble() * 200.0);
            }

            this.tChart.Legend.Alignment = LegendAlignments.Top;
            this.tChart.Legend.CheckBoxes = true;
            this.tChart.Aspect.View3D = false;
            this.tChart.GetLegendText += new GetLegendTextEventHandler(tChart_GetLegendText);
            this.tChart.Dock = DockStyle.Fill;
            this.tChart.AutoRepaint = true;
            this.Controls.Add(this.tChart);

            this.timer.Elapsed += new System.Timers.ElapsedEventHandler(timer_Elapsed);
            this.timer.Start();
        }

        void timer_Elapsed(object sender, System.Timers.ElapsedEventArgs e)
        {
            lock(this.chartLock)
            {
                for(int i = 0; i < this.lines.Length; i++)
                {
                    this.lines[i].Add(DateTime.Now, this.random.NextDouble() * 200.0);
                }

                this.tChart.Draw();
            }
        }

        void tChart_GetLegendText(object sender, GetLegendTextEventArgs e)
        {
            lock(this.chartLock)
            {
                e.Text += " " + this.tChart.Chart.FormattedValueLegend(this.tChart.Series[e.Index], this.tChart.Series[e.Index].Count - 1);
            }
        }
    }
}
